"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var storage_1 = require("./storage");
var Symbols_1 = require("./model/Symbols");
var SymbolsView_1 = require("./view/SymbolsView");
var SymbolsCommands_1 = require("./SymbolsCommands");
var traits_1 = require("./view/traits");
exports.default = (function (editor, opts) {
    if (opts === void 0) { opts = {}; }
    var options = __assign({
        appendTo: '#symbols',
        emptyText: 'No symbol yet.',
        primaryColor: '#b9a5a6',
        secondaryColor: '#463a3c',
        highlightColor: '#d97aa6',
    }, opts);
    // store the symbols data with the site
    (0, storage_1.default)(editor);
    // keep track of symbols and changes
    editor.Symbols = new Symbols_1.Symbols([], { options: options, editor: editor });
    editor.on('load', function () {
        // Display symbols
        new SymbolsView_1.default(__assign(__assign({}, options), { editor: editor, model: editor.Symbols }));
        // Commands to create/delete symbols
        (0, SymbolsCommands_1.default)(editor);
        // Add traits like a plugin
        (0, traits_1.default)(editor, options);
    });
});
//# sourceMappingURL=index.js.map