"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var globals_1 = require("@jest/globals");
var utils_1 = require("./utils");
var test_utils_1 = require("./test-utils");
(0, globals_1.test)('Test find', function () {
    var _a = (0, test_utils_1.getTestSymbols)(), comp1 = _a.comp1, child11 = _a.child11, child111 = _a.child111;
    // all children have symbolChildId set
    (0, globals_1.expect)((0, utils_1.find)(comp1, 'not-an-id')).toBeNull();
    // unknown symbolChildId
    (0, globals_1.expect)((0, utils_1.find)(comp1, 'unknown')).toBeNull();
    // find one child
    (0, globals_1.expect)((0, utils_1.find)(comp1, child11.get('symbolChildId'))).toBe(child11);
    // find one child of a child
    (0, globals_1.expect)((0, utils_1.find)(comp1, child111.get('symbolChildId'))).not.toBeNull();
    var found = (0, utils_1.find)(comp1, child111.get('symbolChildId'));
    (0, globals_1.expect)(found.cid).toBe(child111.cid);
    // This makes jest crash: expect(find(comp1, child111.get('symbolChildId'))).toBe(child111)
});
(0, globals_1.test)('Test closestInstance', function () {
    var _a = (0, test_utils_1.getTestSymbols)(), comp1 = _a.comp1, child11 = _a.child11;
    var nullComp = null;
    (0, globals_1.expect)((0, utils_1.closestInstance)(nullComp)).toBeNull();
    (0, globals_1.expect)((0, utils_1.closestInstance)(comp1)).toBe(comp1);
    (0, globals_1.expect)((0, utils_1.closestInstance)(child11)).toBe(comp1);
});
//# sourceMappingURL=utils.test.js.map